#
# $Id: xulrunner.spec,v 1.0 2004/10/21 15:48:39 legion Exp $
#

%def_without 	debug
%def_with 	svg
%def_with 	libxul

Summary:        XUL Runner
Name:           xulrunner
Version:        1.8.0.4
Release:       	alt4
License:        MPL/GPL
Group:          Development/Other
Url:		http://wiki.mozilla.org/XUL:Xul_Runner

Source0:	xulrunner-source.tar
Source1:	fix_headers.sh

Patch1:		patch-system-nss-12-trunk.patch
Patch2:		firefox-1.5.0.1-alt-asm-directive.patch
Patch3:		xulrunner-alt-devel-path-fix.patch
Patch4:		xulrunner-alt-extensions-dir.patch
Patch5:		mozilla-firefox-1.0-lib64.patch
Patch6:		xulrunner-alt-remove-version-pc.patch
Patch7:		xulrunner-symbols-fix.patch

BuildRequires: doxygen gcc-c++ imake libgtk+2-devel libIDL-devel libjpeg-devel 
BuildRequires: libnss-devel-static libXinerama-devel libXp-devel libXt-devel 
BuildRequires: makedepend nss-utils unzip xorg-cf-files zip chrpath

#Requires:	gtk+2 >= 2.2.0 freetype2 zip libnspr libnss

BuildRequires: autoconf_2.13
%set_autoconf_version 2.13

%define fullname	%name-%version
%define xulrunner_prefix  %_libdir/%fullname

%description
XULRunner is a single "gecko runtime" installable package that can be used to bootstrap 
multiple XUL+XPCOM applications

%package devel
Summary: 	XULRunner development kit.
Group: 		Development/C
Requires: xulrunner = %version-%release

%description devel
XULRunner development kit.

%package -n xulsimple
Summary: 	Simple program
Group: 		Development/Other
Requires: xulrunner

%description -n xulsimple
XUL simple program.

%prep
%setup -q -c -n %fullname
cd %_builddir/%fullname/mozilla

%patch1 -p1 -b .fix1
%patch2 -p1 -b .fix2
%patch3 -p1 -b .fix3
%patch4 -p1 -b .fix4
%patch5 -p1 -b .fix5
%patch6 -p2 -b .fix6
%patch7 -p1 -b .fix7

%build
cd %_builddir/%fullname/mozilla

%add_optflags %optflags_shared
%add_findprov_lib_path %xulrunner_prefix

%__subst 's|AC_CONFIG_AUX_DIR(\${srcdir}/build/autoconf)|AC_CONFIG_AUX_DIR(build/autoconf)|' configure.in
%__autoconf

# Add fake RPATH
rpath="/$(printf %%s '%xulrunner_prefix' |tr '[:print:]' '_')"
export LDFLAGS="$LDFLAGS -Wl,-rpath,$rpath"
export LIBIDL_CONFIG=/usr/bin/libIDL-config-2

%configure \
	--prefix=%_prefix \
	--disable-activex \
	--disable-activex-scripting \
	--disable-tests \
	--disable-oji \
	--disable-installer \
	--disable-updater \
	--disable-tests \
	--disable-freetype2 \
	--disable-javaxpcom \
	--enable-xft \
	--enable-crypto \
	--enable-application=xulrunner \
	--enable-optimize="-O2" \
	--enable-default-toolkit=gtk2 \
	--enable-extensions=default,cookie,permissions \
	\
%if_with debug
	--disable-strip \
	--enable-debug \
	--enable-debug-modules \
	--enable-logrefcnt \
	--enable-debugger-info-modules \
	--enable-detect-webshell-leaks \
%else
	--enable-strip \
	--disable-debug \
%endif # debug
	\
%if_with svg
	--enable-svg \
  	--enable-svg-renderer-cairo \
%endif # svg
	\
%if_with libxul
	--enable-libxul \
%endif # libxul
	\
	--enable-canvas \
	--with-system-jpeg \
	--with-system-png \
	--with-system-zlib \
	--with-system-nspr \
	--with-system-nss \
	--with-pthreads \
	#

%make_build

%install
cd %_builddir/%fullname/mozilla
%__mkdir_p \
    %buildroot/%xulrunner_prefix/install \
    %buildroot/%xulrunner_prefix/extensions \
    #

%makeinstall \
	idldir=%buildroot/%_datadir/idl/%name \
	includedir=%buildroot/%_includedir/%name \
	mozappdir=%buildroot/%xulrunner_prefix \
	#

%SOURCE1 %_includedir %buildroot/%_includedir/%name

%__rm -rf \
    %buildroot/%xulrunner_prefix/TestGtkEmbed \
    %buildroot/%xulrunner_prefix/install \
    %buildroot/%_libdir/pkgconfig/xulrunner-nspr.pc \
    %buildroot/%_libdir/pkgconfig/xulrunner-nss.pc \
    #

# make package link 
%__ln_s %fullname %buildroot/%_libdir/%name

###
## XUL Example
###
%__mkdir_p %buildroot/%_libdir/xulsimple-%version
%__cp -rfL dist/xpi-stage/simple/* %buildroot/%_libdir/xulsimple-%version/

%__cat >%buildroot/%_bindir/xulsimple<<EOF
#!/bin/sh -e
%_bindir/%name %_libdir/xulsimple-%version/application.ini
EOF
%__chmod +x %buildroot/%_bindir/xulsimple

# Add real RPATH
rpath="/$(printf %%s '%xulrunner_prefix' |tr '[:print:]' '_')"
find \
    "%buildroot%xulrunner_prefix" \
    "%buildroot/%_libdir/xulsimple-%version/" \
    -type f | 
while read f; do
  %__file "$f" | grep -qs ELF || continue
  if chrpath -l "$f" | fgrep -qs "RPATH=$rpath"; then
    chrpath -r "%xulrunner_prefix" "$f"
  fi
done

%files
%_bindir/%name
%_libdir/%name
%_libdir/%fullname
%exclude %xulrunner_prefix/regxpcom
%exclude %xulrunner_prefix/xpcshell
%exclude %xulrunner_prefix/xpicleanup
%exclude %xulrunner_prefix/xpidl
%exclude %xulrunner_prefix/xpt_dump
%exclude %xulrunner_prefix/xpt_link

%files devel
%_bindir/%name-config
%xulrunner_prefix/regxpcom
%xulrunner_prefix/xpcshell
%xulrunner_prefix/xpicleanup
%xulrunner_prefix/xpidl
%xulrunner_prefix/xpt_dump
%xulrunner_prefix/xpt_link
%_libdir/pkgconfig/*
%_datadir/idl/%name
%_includedir/%name

%files -n xulsimple
%_bindir/xulsimple
%_libdir/xulsimple-%version

%changelog
* Tue Feb 27 2007 Alexey Gladkov <legion@altlinux.ru> 1.8.0.4-alt4
- Remove requires nspr with version from *.pc

* Thu Oct 19 2006 Alexey Gladkov <legion@altlinux.ru> 1.8.0.4-alt3
- Add cookie and permissions extensions.

* Fri Sep 22 2006 Alexey Gladkov <legion@altlinux.ru> 1.8.0.4-alt2
- Fix Cflags in *.pc

* Wed Aug 30 2006 Alexey Gladkov <legion@altlinux.ru> 1.8.0.4-alt1
- New version (1.8.0.4-alt1).
- Update BuildRequires.

* Thu Jul 06 2006 Alexey Gladkov <legion@altlinux.ru> 1.8.0.1-alt2
- fixed build system.

* Sat Mar 25 2006 Alexey Gladkov <legion@altlinux.ru> 1.8.0.1-alt1
- new version.
- Build with system NSS and NSPR.
- Build libxul.
- Header bugfix.
- Directory /usr/share/xulrunner-@version@/extensions was added to extensions search path .
  * this location is controled by the option extensions.dir.extensions .

* Thu Jun 16 2005 Alexey Gladkov <legion@altlinux.ru> 0.0.0-alt1
- first build for ALT Linux.
